#ifndef _LIST_H
#define _LIST_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _node {
  struct _node *pred, *succ;
  void *data;
} Node;

enum NodePosition {CurrentLeft, CurrentRight};

Node *initNode(void);
Node *addNode(Node *, void *, enum NodePosition);
Node *delNode(Node *);

typedef struct  _list {
  Node *head, *tail;
  int nodes;
} List;

List *newList(void);
void deleteList(List *);
Node *addTail(List *, void *);
Node *addHead(List *, void *);
Node *setCurr(List *, void *, int (*)(void *, void *));
void delNodeInList(List *, Node *);
void delNodeAndDataInList(List *, Node *);
void delTail(List *);
void delTailAndData(List *);
void resetList(List *);
void printList(List *, char *(*)(void *));
int getNumOfNodesInList(List *);
int emptyList(List *);
/* for lifo-, fifo operations */
Node *getFirstNode(List *);
Node *getLastNode(List *);
void delFirstNode(List *);
void delFirstNodeAndData(List *);
void delLastNode(List *);
void delLastNodeAndData(List *);

#endif
