
/*
 * Project: Vme interface(s)
 *
 * File   : vme.h
 *
 * Purpose: General header file for vme functions
 *
 * $Date
 * $Id: vme.h,v 0.1 1998/10/08 11:21:34 dirk Exp $
 * $Revision: 0.1 $
 */
 
#ifndef _linux_vme_h_
#define _linux_vme_h_

 /* --- Defaults for Vme AM codes --- */

#define AM_STD_SUP_BLOCK        0x3f  /* standard supervisory block transfer */
#define AM_STD_SUP_PROG         0x3e  /* standard supervisory program access */
#define AM_STD_SUP_DATA         0x3d  /* standard supervisory data access */
#define AM_STD_NONPRIV_BLOCK    0x3b  /* standard non-priv. block transfer */
#define AM_STD_NONPRIV_PROG     0x3a  /* standard non-priv. programm access */
#define AM_STD_NONPRIV_DATA     0x39  /* standard non-priv. data access */

#define AM_SHORT_SUP            0x2d  /* short supervisory access */
#define AM_SHORT_NONPRIV        0x29  /* short non-priviledged access */

#define AM_USER_1F              0x1f  /* user defined am codes */
#define AM_USER_1E              0x1e
#define AM_USER_1D              0x1d
#define AM_USER_1C              0x1c
#define AM_USER_1B              0x1b
#define AM_USER_1A              0x1a
#define AM_USER_19              0x19
#define AM_USER_18              0x18
#define AM_USER_17              0x17
#define AM_USER_16              0x16
#define AM_USER_15              0x15
#define AM_USER_14              0x14
#define AM_USER_13              0x13
#define AM_USER_12              0x12
#define AM_USER_11              0x11
#define AM_USER_10              0x10

#define AM_EXT_SUP_BLOCK        0x0f  /* extended supervisory block transfer */
#define AM_EXT_SUP_PROG         0x0e  /* extended supervisory program access */
#define AM_EXT_SUP_DATA         0x0d  /* extended supervisory data access */
#define AM_EXT_NONPRIV_BLOCK    0x0b  /* extended non-priv. block transfer */
#define AM_EXT_NONPRIV_PROG     0x0a  /* extended non-priv. program access */
#define AM_EXT_NONPRIV_DATA     0x09  /* extended non-priv. data access */

/* --- VME Rev. D enhancements --- */

#define AM_LONG_SUP_BLOCK       0x07  /* long supervisory block transfer */
#define AM_LONG_SUP_PROG        0x06  /* long supervisory program access */
#define AM_LONG_SUP_DATA        0x05  /* long supervisory data access */
#define AM_LONG_NONPRIV_BLOCK   0x03  /* long non-priv. block transfer */
#define AM_LONG_NONPRIV_PROG    0x02  /* long non-priv. program access */
#define AM_LONG_NONPRIV_DATA    0x01  /* long non-priv. data access */

#endif  /* _linux_vme_h_ */
