
/*
 * File   : test1.c
 *
 * Purpose: Test program for ATVME interface kit
 *          Try to access some hardware locations
 *
 * $Revision: 0.3 $
 * $Date: 1998/11/10 16:29:15 $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef __WATCOMC__
# include <dos.h>
# include <conio.h>
#endif /* __WATCOMC__ */

#include <atvme.h>
#include <vme.h>

extern int errno;

main ( void )
 {
  char data;
  int i, mem_base;
  VmeDesc vme;
  
  printf ( "AtvmeOpen: %d %d\n", AtvmeOpen(), errno );

  printf ( "AtvmeCheckConnection: %d\n", AtvmeCheckConnection() );
  
  printf ( "AtvmeResetVme: %d %d\n", AtvmeResetVme(), errno );
  printf ( "AtvmeResetVme: %d %d\n", AtvmeResetVme(), errno );

  sleep ( 1 );
#if 1
  printf ( "Testing 'A16D8' ...\n" );
  InitVmeDesc ( vme, NULL, VME_D8 | VME_A16 );
  
  for ( i=0x101; i<0x14f; i+= 0x2 )
   {
    SetVmeAddr ( vme, (unsigned int *)i );
    printf ( "%2x\n", VmeReadChar ( &vme ) );
  }

  sleep ( 3 );
#endif
  
#if 0
  printf ( "Testing 'A24D8' at addr=0xfc3e01...\n" );
  InitVmeDesc ( vme, NULL, VME_D8 | VME_A24 );
  
  for ( i=0xfc3e01; i<0xfc3e20; i+=2 )
   {
    SetVmeAddr ( vme, (unsigned int *)i );
    printf ( "Read: %2x\n", VmeReadChar ( &vme ) );
  }

  sleep ( 3 );
#endif
  
#if 0
  printf ( "Testing 'A24D16' at addr=0xf00000...\n" );
  InitVmeDesc ( vme, NULL, VME_D16 | VME_A24 );

  for ( i=0; i<100; i++ )
   {
    SetVmeAddr ( vme, (unsigned int *)0xf00000 );
    printf ( "Read: %4x\n", VmeReadShort ( &vme ) );
  }
#endif
  AtvmeShutdown();
}

/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
