
/*
 * File   : test2.c
 *
 * Purpose: Test program for ATVME interface kit
 *
 *
 * $Revision: 1.6 $
 * $Date: 1999/02/17 13:33:56 $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef __WATCOMC__
# include <dos.h>
# include <conio.h>
#endif /* __WATCOMC__ */

#include <atvme.h>
#include <time.h>

extern int errno;

void sig_handler(int sig)
{
  IntAckStruct *int_ack;
  switch (sig) {
  case SIGUSR1:
    int_ack = AtvmeGetNextPendingInt();
    if (int_ack) {
      printf("sig_handler(): Int %x occured at %Ld\n",int_ack->int_vec,int_ack->int_tl);
      free(int_ack);
    }
  break;
  default:
    printf("blabla\n");
  }
}

void main ( void )
 {
  unsigned char *ret;
  struct timeval tv = {0,100};
  IntAckStruct *int_ack;
  int atvme_fd;
  int i,w;
  
  printf ( "AtvmeOpen: %d %d\n", atvme_fd = AtvmeOpen(), errno );
  if (atvme_fd < 0) exit(1);

  printf ( "AtvmeCheckConnection: %d\n", AtvmeCheckConnection() );
  
  printf ( "AtvmeResetVme: %d %d\n", AtvmeResetVme(), errno );

  AtvmeSetMode(ATVME_A24 | ATVME_D16 | ATVME_DATA | ATVME_NONPRIV);

#if 1
  /* register interrupt handler and enable int */

  AtvmeEnableInterrupt();
  AtvmePostInterrupt(AtvmeRoak, 0x0, 0x20,
                     ATVME_A24 | ATVME_D16 | ATVME_DATA | ATVME_NONPRIV);

  printf ( "Testing interrupts ...\n" );

#if 0
  /* --- test for select() call --- */
  
  /* wait here for interrupts queued to pendingInts */
  printf("Waiting for interrupts for 10 secs ...\n");
  sleep(10);
  while (AtvmeSelect(&tv)) {
    int_ack = getNextPendingInt();
    if (int_ack) {
      printf("Int %x occured at %Ld\n",int_ack->int_vec,int_ack->int_tl);
      free(int_ack);
    } else {
      printf("Sorry, no int available!\n");
    }
  }
#endif
  printf("Waiting for interrupts for 10 secs ...\n");
  AtvmeSignal(sig_handler);
  for (i=0;i<500;i++) usleep(1000);
#endif

#if 0
  /* --- test for mmap() call --- */
  
  /* assign mem range [0xd0000,0xdffff] to user buffer ret */
  /* do the mapping only once! */ 

  ret = AtvmeMMap();
  /* choose appropriate 64K page on VME bus */
  AtvmeSet64KPage(0xf00000);
  /* accessing I2C module */
  if (ret) {
#if 0
    for (i=0;i<0x20;i+=2) {
      w = *(unsigned short *)(ret + i);
      printf("w = %x ", w);
    }
    printf("\n");
#endif
    *(unsigned short *)(ret+0) = 0x5555;
    *(unsigned short *)(ret+2) = 0x5555;
  } else {
    printf("Sorry, no remap!\n");
  }
#endif

  AtvmeShutdown();
}

/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
