
/*
 * Project: Vme interface(s)
 *
 * File   : vme.h
 *
 * Purpose: General header file for vme functions
 *          So when it is intended to use another Vme-Controller:
 *          ==> just change a #define !
 *
 * $Date: 1999/01/25 09:53:16 $
 * $Id: vme.h,v 0.6 1999/01/25 09:53:16 wiegert Exp $
 * $Revision: 0.6 $
 */
 
#ifndef _vme_h_
#define _vme_h_

#ifdef ATVME                       /* --- ??? --- */
# include <linux/vme.h>
#endif

#ifdef __WATCOMC__
# undef TVC
# define ATVME
#endif

#ifdef TVC

#include <vmetvc.h>

#define VME_A16      TVC_A16
#define VME_A24      TVC_A24
#define VME_A32      TVC_A32
#define VME_D8       TVC_D8
#define VME_D16      TVC_D16
#define VME_D32      TVC_D32

#define VmeDesc VMELOC

#define VmeInit()                       VmeInit()

#define VmeGetVersionString()           "VmeTvc Version"

#define VmeWriteChar(_vme,_data)        VmeOutChar(_vme,_data)
#define VmeReadChar(_vme)               VmeInChar(_vme)
#define VmeWriteShort(_vme,_data)       VmeOutShort(_vme,_data)
#define VmeReadShort(_vme)              VmeInShort(_vme)
#define VmeWriteInt(_vme,_data)         VmeOutInt(_vme,_data)
#define VmeReadInt(_vme)                VmeInInt(_vme)

#define InitVmeDesc(_x,_addr,_acc)      { _x.addr = (void *)(_addr); \
                                          _x.acc = (_acc); }
#define SetVmeAddr(_x,_addr)            { _x.addr = (void *)(_addr); }

#endif /* ------ TVC ------ */

#ifdef ATVME

#include <atvme.h>

#define VME_A16      ATVME_A16
#define VME_A24      ATVME_A24
#define VME_A32      ATVME_A32
#define VME_D8       ATVME_D8
#define VME_D16      ATVME_D16
#define VME_D32      ATVME_D32

#define InitVmeDesc(_x,_addr,_acc)      { _x.addr = (void *)(_addr); \
                                          _x.acc = (_acc); }
#define SetVmeAddr(_x,_addr)            { _x.addr = (void *)(_addr); }

#define VmeInit()                       AtvmeOpen()
#define VmeReset()			AtvmeResetVme()

#define VmeGetVersionString()           AtvmeGetVersionString()

#define VmeSetSysFail()		        AtvmeSetSysFail()
#define VmeClearSysFail()	        AtvmeClearSysFail()
#define VmeCheckSysFail()	        AtvmeCheckSysFail()

/* --- for interrupts --- */

#define VmeIntAckStruct			IntAckStruct
#define VmeEnableInterrupt()            AtvmeEnableInterrupt()
#define VmeDisableInterrupt()           AtvmeDisableInterrupt()
#define VmeAttachInterrupt(_ack_type,_ack_adr,_int_vec,_am) \
	AtvmePostInterrupt(_ack_type,_ack_adr,_int_vec,_am)
#define VmeRemoveInterrupt(_int_vec)    AtvmeRemoveInterrupt(_int_vec)
#define VmeSelect(_x)			AtvmeSelect(_x)
#define VmeGetNextPendingInt()		AtvmeGetNextPendingInt()

typedef enum
 { 
  VME_ROAK = AtvmeRoak, 
  VME_RORA_BY_USER = AtvmeRoraByUser, 
  VME_RORA_BY_HANDLER = AtvmeRoraByHandler

} VmeAckType;

#endif  /* ------ ATVME ------ */

#ifdef BIT3_617

#include <bit3_vme.h>

#define VME_A16         BIT3_VME_A16
#define VME_A24         BIT3_VME_A24
#define VME_A32      	BIT3_VME_A32
#define VME_D8          BIT3_VME_D8
#define VME_D16         BIT3_VME_D16
#define VME_D32         BIT3_VME_D32

#define VmeDesc				Bit3VmeDesc
#define InitVmeDesc(_x,_addr,_acc)	Bit3InitVmeDesc(_x,_addr,_acc)
#define SetVmeAddr(_x,_addr)		Bit3SetVmeAddr(_x,_addr)

#define VmeInit()			Bit3VmeOpen()

#define VmeGetVersionString()		Bit3VmeGetVersionString()

#define VmeReadChar(_vme)		Bit3VmeReadChar(_vme)
#define VmeWriteChar(_vme,_data)	Bit3VmeWriteChar(_vme,_data)
#define VmeReadShort(_vme)		Bit3VmeReadShort(_vme)
#define VmeWriteShort(_vme,_data)	Bit3VmeWriteShort(_vme,_data)

#endif  /* ----- BIT3_617 ----- */

#endif  /* _vme_h_ */
